<?php
/*
Plugin Name:  Photos from one year ago
Version: 0.5.beta5
Description: Add a "photos from one year ago" link in "Specials" menu.
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=893
Author: ddtddt
Author URI: http://temmii.com/piwigo/
*/

// +-----------------------------------------------------------------------+
// | Photos from one year ago for Piwigo by TEMMII                         |
// +-----------------------------------------------------------------------+
// | Copyright(C) 2008-2020 ddtddt               http://temmii.com/piwigo/ |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

defined('PHPWG_ROOT_PATH') or die('Hacking attempt!');

define('PFOYA_PATH' , PHPWG_PLUGINS_PATH . basename(dirname(__FILE__)) . '/');

add_event_handler('loading_lang', 'pfoya_loading_lang');	  
function pfoya_loading_lang(){
  load_language('plugin.lang', PFOYA_PATH);
}

add_event_handler('blockmanager_apply' , 'add_link_pfoya');
add_event_handler('loc_end_section_init', 'section_init_pfoya');
  
function add_link_pfoya($menu_ref_arr){
  global $conf;
  $menu = &$menu_ref_arr[0];
  $position = (isset($conf['pfoya_position']) and is_numeric($conf['pfoya_position'])) ? $conf['pfoya_position'] : 5;
  if (($block = $menu->get_block('mbSpecials')) != null){
	array_splice($block->data, $position-1, 0, 
	  array('photos_from_one_year_ago' =>
		array(
		  'URL' => make_index_url(array('section' => 'photos_from_one_year_ago')),
		  'TITLE' => l10n('Displays photos from one year ago'),
		  'NAME' => l10n('Photos from one year ago')
		)
	  )
	);
  }
}

function section_init_pfoya(){
  global $tokens, $page, $conf, $template;
  $testurl = explode('photos_from_', $_SERVER['REQUEST_URI']);
  if(!empty($testurl[1])){

    $datepfoya = (isset($conf['pfoya_dateb'])) ? $conf['pfoya_dateb'] : "date_available";
	$daydatemax= (isset($conf['pfoya_datemax'])) ? $conf['pfoya_datemax'] : 5;

	if($daydatemax>1)$template->assign('pfoya','a');
	
	for ($i = 1; $i <= $daydatemax; $i++) {
	$daydate=date("Y-m-d", strtotime('-'.$i.' year'));
	  $query = '
		SELECT COUNT(DISTINCT(i.id)) as count 
		FROM '.IMAGES_TABLE.' AS i
		INNER JOIN '.IMAGE_CATEGORY_TABLE.' AS ic ON i.id = ic.image_id
		INNER JOIN '.CATEGORIES_TABLE.' AS c ON ic.category_id = c.id 
		WHERE ' .  
		  get_sql_condition_FandF(
			array(
			  'forbidden_categories' => 'category_id',
			  'visible_categories' => 'category_id',
			  'visible_images' => 'image_id',
			  ),
			'', true
			);
	  $query .= '
		and DATE ('.$datepfoya.') ="'.$daydate.'";';

		$row = pwg_db_fetch_assoc(pwg_query($query));
		
	  if ($i == 1){
	    $items = array(
		  'NB_IMAGES' => $row['count'],
		  'URL' => make_index_url(array('section' => 'photos_from_one_year_ago')),
		  'LABEL' => l10n('Photos from one year ago'),
		);
	    $template->append('pfoyas', $items);
	  }else{
		$items = array(
		  'NB_IMAGES' => $row['count'],
		  'URL' => make_index_url(array('section' => 'photos_from_'.$i.'_year_ago')),
		  'LABEL' => l10n('Photos from %d years ago',$i),
		);
	    $template->append('pfoyas', $items);
	  }
	}
	  if($testurl[1]=='one_year_ago'){
		if (!in_array('photos_from_one_year_ago', $tokens)){return;}
		  	$daydate=date("Y-m-d", strtotime('-1 year'));
		    $query = '
			  SELECT DISTINCT(i.id)
			  FROM '.IMAGES_TABLE.' AS i
				INNER JOIN '.IMAGE_CATEGORY_TABLE.' AS ic ON i.id = ic.image_id
				INNER JOIN '.CATEGORIES_TABLE.' AS c ON ic.category_id = c.id 
				WHERE ' .  
				  get_sql_condition_FandF(
					array(
					  'forbidden_categories' => 'category_id',
					  'visible_categories' => 'category_id',
					  'visible_images' => 'image_id',
					  ),
					'', true
					);
			  $query .= '
				   and DATE ('.$datepfoya.') ="'.$daydate.'";';
		$page['section'] = 'photos_from_one_year_ago';
	    $page['title'] = '<a href="' . duplicate_index_url() . '">' . l10n('Photos from one year ago') . '</a>';
	    $page['section_title'] = '<a href="'.get_gallery_home_url().'">' . l10n('Home') . '</a>'
		  . $conf['level_separator'] . $page['title'];
	    $page['items'] = query2array($query, null, 'id');
		$template->assign('pfoyadata',l10n('Photos from').' '.format_date($daydate));

	  }else{
		$yurl=explode('_year_ago', $testurl[1]);
		$yurl=$yurl[0];
		if (!in_array('photos_from_'.$yurl.'_year_ago', $tokens)){return;}
		$daydate=date("Y-m-d", strtotime('-'.$yurl.' year'));
		  $query = '
		  SELECT DISTINCT(i.id)
		  FROM '.IMAGES_TABLE.' AS i
			INNER JOIN '.IMAGE_CATEGORY_TABLE.' AS ic ON i.id = ic.image_id
			INNER JOIN '.CATEGORIES_TABLE.' AS c ON ic.category_id = c.id 
			WHERE ' .  
			  get_sql_condition_FandF(
				array(
				  'forbidden_categories' => 'category_id',
				  'visible_categories' => 'category_id',
				  'visible_images' => 'image_id',
				  ),
				'', true
				);
		  $query .= '
			   and DATE ('.$datepfoya.') ="'.$daydate.'";';
		$page['section'] = 'photos_from_'.$yurl.'_year_ago';
	    $page['title'] = '<a href="' . duplicate_index_url() . '">' . l10n('Photos from %d years ago',$yurl) . '</a>';
	    $page['section_title'] = '<a href="'.get_gallery_home_url().'">' . l10n('Home') . '</a>'
		  . $conf['level_separator'] . $page['title'];
	    $page['items'] =query2array($query, null, 'id'); 
		$template->assign('pfoyadata',l10n('Photos from').' '.format_date($daydate));
	  }
	  
	
  }	
	
  $template->set_filename('PFOYA', realpath(PFOYA_PATH . 'pfoya.tpl'));
  $template->assign_var_from_handle('CONTENT', 'PFOYA');
	
}

add_event_handler('get_stuffs_modules', 'register_pfoya_module');

function register_pfoya_module($modules){
  array_push($modules, array(
    'path' => PFOYA_PATH.'/blockhome',
    'name' => l10n('Photos from one year ago'),
    'description' => l10n('Display X photos from one year ago in the gallery or a album'),
    )
  );
  return $modules;
}





   





